(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     12896,        445]
NotebookOptionsPosition[     11142,        382]
NotebookOutlinePosition[     11611,        400]
CellTagsIndexPosition[     11568,        397]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\
PID regul\[AAcute]tor + soustava
P\[RHacek]\[IAcute]m\[EAcute] \[RHacek]e\[SHacek]en\[IAcute] diferenci\
\[AAcute]ln\[IAcute]ch rovnic\
\>", "Section"],

Cell[CellGroupData[{

Cell["Vstupn\[IAcute] hodnoty", "Subsection"],

Cell[BoxData[
 RowBox[{"dos", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"A", "\[Rule]", "1"}], ",", 
    RowBox[{"Kp", "\[Rule]", "2.6"}], ",", 
    RowBox[{"Ti", "\[Rule]", "1"}], ",", 
    RowBox[{"Kd", "\[Rule]", "1"}], ",", 
    RowBox[{"p", "\[Rule]", "1"}], ",", 
    RowBox[{"i", "\[Rule]", "1"}], ",", 
    RowBox[{"d", "\[Rule]", "1"}], ",", 
    RowBox[{"Ts", "\[Rule]", "5"}]}], "}"}]}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Soustava rovnic", "Subsection"],

Cell[BoxData[
 RowBox[{"rce", "=", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"e", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"w", "[", "t", "]"}], "-", 
       RowBox[{"r", "[", "t", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"up", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"p", "*", "Kp", "*", 
       RowBox[{"e", "[", "t", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"i", "*", 
       RowBox[{"e", "[", "t", "]"}]}], "==", 
      RowBox[{"Ti", "*", 
       RowBox[{
        RowBox[{"ui", "'"}], "[", "t", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"ui", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
     RowBox[{
      RowBox[{"ud", "[", "t", "]"}], "\[Equal]", 
      RowBox[{"d", "*", "Kd", "*", 
       RowBox[{
        RowBox[{"e", "'"}], "[", "t", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"e", "[", "0", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"w", "[", "0", "]"}], "-", 
       RowBox[{"r", "[", "0", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{"u", "[", "t", "]"}], "\[Equal]", 
      RowBox[{
       RowBox[{"up", "[", "t", "]"}], "+", 
       RowBox[{"ui", "[", "t", "]"}], "+", 
       RowBox[{"ud", "[", "t", "]"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"r", "[", "t", "]"}], "+", 
       RowBox[{"Ts", "*", 
        RowBox[{
         RowBox[{"r", "'"}], "[", "t", "]"}]}]}], "\[Equal]", 
      RowBox[{"u", "[", "t", "]"}]}], ",", 
     RowBox[{
      RowBox[{"r", "[", "0", "]"}], "\[Equal]", "0"}], ",", 
     RowBox[{
      RowBox[{"w", "[", "t", "]"}], "\[Equal]", "A"}], ",", 
     RowBox[{
      RowBox[{"w", "[", "0", "]"}], "\[Equal]", "A"}]}], "}"}], "/.", 
   "dos"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"res", "=", 
  RowBox[{
   RowBox[{"NDSolve", "[", 
    RowBox[{"rce", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"r", "[", "t", "]"}], ",", 
       RowBox[{"e", "[", "t", "]"}], ",", 
       RowBox[{"up", "[", "t", "]"}], ",", 
       RowBox[{"ui", "[", "t", "]"}], ",", 
       RowBox[{"ud", "[", "t", "]"}], ",", 
       RowBox[{"u", "[", "t", "]"}], ",", 
       RowBox[{"w", "[", "t", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "50"}], "}"}]}], "]"}], "[", 
   RowBox[{"[", "1", "]"}], "]"}]}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["V\[YAcute]stup", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"vystup", "[", "t_", "]"}], "=", 
   RowBox[{
    RowBox[{"r", "[", "t", "]"}], "/.", "res"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"%", ",", 
     RowBox[{"1", "-", 
      RowBox[{"Exp", "[", 
       RowBox[{
        RowBox[{"-", "t"}], "/", "5"}], "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "30"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t(s)\>\"", ",", "\"\<r(-)\>\""}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Hue", "[", "0.6", "]"}], ",", 
      RowBox[{"Hue", "[", "0", "]"}]}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.4759174128125*^9, 3.47591745078125*^9}, {
  3.6215913789235106`*^9, 3.621591400430741*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"t", ",", 
      RowBox[{"vystup", "[", "t", "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", "20"}], "}"}]}], "]"}], ";"}]], "Input",
 CellChangeTimes->{3.6215914116723843`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Ak\[CHacek]n\[IAcute] veli\[CHacek]ina", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"akce", "[", "t_", "]"}], "=", 
   RowBox[{
    RowBox[{"u", "[", "t", "]"}], "/.", "res"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "30"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t(s)\>\"", ",", "\"\<u(-)\>\""}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"Hue", "[", "0.6", "]"}]}]}], "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"vystup", "[", "t", "]"}], ",", 
     RowBox[{"akce", "[", "t", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "50"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t(s)\>\"", ",", "\"\<r,u(-)\>\""}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"RGBColor", "[", 
       RowBox[{"0", ",", "1", ",", "0"}], "]"}], ",", 
      RowBox[{"RGBColor", "[", 
       RowBox[{"1", ",", "0", ",", "0"}], "]"}]}], "}"}]}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "400"}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0"}], "}"}]}]}], "]"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Regula\[CHacek]n\[IAcute] odchylka", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"odchylka", "[", "t_", "]"}], "=", 
   RowBox[{
    RowBox[{"e", "[", "t", "]"}], "/.", "res"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Plot", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "30"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t(s)\>\"", ",", "\"\<e(-)\>\""}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"Hue", "[", "0.6", "]"}]}]}], "]"}]}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Slo\[ZHacek]ky regul\[AAcute]toru", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"pslozka", "[", "t_", "]"}], "=", 
   RowBox[{
    RowBox[{"up", "[", "t", "]"}], "/.", "res"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"islozka", "[", "t_", "]"}], "=", 
   RowBox[{
    RowBox[{"ui", "[", "t", "]"}], "/.", "res"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"dslozka", "[", "t_", "]"}], "=", 
   RowBox[{
    RowBox[{"ud", "[", "t", "]"}], "/.", "res"}]}], ";"}]}], "Input"],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"pslozka", "[", "t", "]"}], ",", 
     RowBox[{"islozka", "[", "t", "]"}], ",", 
     RowBox[{"dslozka", "[", "t", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "30"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t(s)\>\"", ",", "\"\<u(-)\>\""}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"RGBColor", "[", 
       RowBox[{"1", ",", "0", ",", "0"}], "]"}], ",", 
      RowBox[{"RGBColor", "[", 
       RowBox[{"0", ",", "1", ",", "0"}], "]"}], ",", 
      RowBox[{"RGBColor", "[", 
       RowBox[{"0", ",", "0", ",", "1"}], "]"}]}], "}"}]}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"pslozka", "[", "t", "]"}], "+", 
    RowBox[{"islozka", "[", "t", "]"}], "+", 
    RowBox[{"dslozka", "[", "t", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "30"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t(s)\>\"", ",", "\"\<u(-)\>\""}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"Hue", "[", "0.6", "]"}]}]}], "]"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Kvalita regulace", "Subsection"],

Cell[CellGroupData[{

Cell["Maxim\[AAcute]ln\[IAcute] p\[RHacek]ekmit", "Subsubsection"],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"vystup", "[", "t", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "20"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<t(s)\>\"", ",", "\"\<y(-)\>\""}], "}"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", 
    RowBox[{"Hue", "[", "0.6", "]"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}]}]}], "]"}]], "Input"],

Cell[BoxData[{
 RowBox[{"ymax", "=", 
  RowBox[{"FindMaximum", "[", 
   RowBox[{
    RowBox[{"vystup", "[", "t", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "5"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"y8", "=", 
  RowBox[{"vystup", "[", "50", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ymax", "[", 
   RowBox[{"[", "1", "]"}], "]"}], "\[LessEqual]", 
  RowBox[{"1.3", "*", "y8"}]}]}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Doba regulace (p\[AAcute]smo 5%)", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FindRoot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"vystup", "[", "t", "]"}], "\[Equal]", 
     RowBox[{"1.05", "*", "y8"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "10"}], "}"}]}], "]"}], "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FindRoot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"vystup", "[", "t", "]"}], "\[Equal]", 
     RowBox[{"0.95", "*", "y8"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "5"}], "}"}]}], "]"}], "//", "Chop"}]}], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Kvadratick\[AAcute] regula\[CHacek]n\[IAcute] plocha", "Subsubsection"],

Cell[BoxData[
 RowBox[{"NIntegrate", "[", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"odchylka", "[", "t", "]"}], ")"}], "2"], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "50"}], "}"}]}], "]"}]], "Input"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowToolbars->"EditBar",
WindowSize->{1157, 802},
WindowMargins->{{4, Automatic}, {Automatic, 1}},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
Magnification->1.25,
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 161, 4, 157, "Section"],
Cell[CellGroupData[{
Cell[753, 30, 45, 0, 59, "Subsection"],
Cell[801, 32, 412, 11, 36, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1250, 48, 37, 0, 59, "Subsection"],
Cell[1290, 50, 1685, 51, 83, "Input"],
Cell[2978, 103, 576, 16, 36, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3591, 124, 36, 0, 59, "Subsection"],
Cell[3630, 126, 920, 27, 83, "Input"],
Cell[4553, 155, 294, 9, 36, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4884, 169, 60, 0, 59, "Subsection"],
Cell[4947, 171, 556, 16, 60, "Input"],
Cell[5506, 189, 835, 23, 60, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6378, 217, 56, 0, 59, "Subsection"],
Cell[6437, 219, 560, 16, 60, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7034, 240, 55, 0, 59, "Subsection"],
Cell[7092, 242, 493, 17, 83, "Input"],
Cell[7588, 261, 871, 23, 60, "Input"],
Cell[8462, 286, 535, 14, 60, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9034, 305, 38, 0, 59, "Subsection"],
Cell[CellGroupData[{
Cell[9097, 309, 66, 0, 49, "Subsubsection"],
Cell[9166, 311, 527, 14, 60, "Input"],
Cell[9696, 327, 429, 12, 83, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10162, 344, 57, 0, 49, "Subsubsection"],
Cell[10222, 346, 529, 17, 60, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10788, 368, 77, 0, 49, "Subsubsection"],
Cell[10868, 370, 234, 7, 42, "Input"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
